

#include "stm32f4xx.h"                  // Device header
/* USER CODE BEGIN Includes */
#include "stdio.h"
#include "stdlib.h"
#include "string.h"
/* USER CODE END Includes */

/* USER CODE BEGIN PV */
/* Private variables ---------------------------------------------------------*/
   char str[1];
   int8_t buffer_data[8] = {0x7E,0xFF,0x06,0x0F,0x00,0x01,0x08,0xEF};
/* USER CODE END PV */   

/* USER CODE BEGIN PFP */
/* Private function prototypes -----------------------------------------------*/   
void USART_Puts (USART_TypeDef* USARTx, volatile char *s){
	
	while(*s){
		
		while(!(USARTx ->SR & 0x00000040) );
		USART_SendData(USARTx,*s);
		*s++;	
		
	}
}

void delayMs(unsigned int MiliSec)
{
	unsigned int i = 0;
	unsigned int j = 0;
	for(i = 0 ; i <= 10000 ; i++)
		for(j = 0 ; j <= MiliSec ; j++);
}

/* USER CODE END PFP */

/**
  * @brief  The application entry point.
  *
  * @retval None
  */
int main(void){

	GPIO_InitTypeDef  GPIO_InitStructure  ;
	USART_InitTypeDef USART_InitStructure ;
	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1,ENABLE);
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3,ENABLE);
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA | RCC_AHB1Periph_GPIOB,ENABLE);
	
	GPIO_InitStructure.GPIO_Mode  =  GPIO_Mode_AF              ;
	GPIO_InitStructure.GPIO_OType =	 GPIO_OType_PP             ;
	GPIO_InitStructure.GPIO_Pin   =  GPIO_Pin_9 | GPIO_Pin_10  ;
	GPIO_InitStructure.GPIO_PuPd  =  GPIO_PuPd_UP              ;
	GPIO_InitStructure.GPIO_Speed =  GPIO_Speed_100MHz         ;
	GPIO_Init(GPIOA,&GPIO_InitStructure)                       ;
		
	GPIO_PinAFConfig(GPIOA,GPIO_PinSource10,GPIO_AF_USART1);
	GPIO_PinAFConfig(GPIOA,GPIO_PinSource9 ,GPIO_AF_USART1);

	USART_InitStructure.USART_BaudRate               = 9600                          ;
	USART_InitStructure.USART_HardwareFlowControl    = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode                   = USART_Mode_Tx | USART_Mode_Rx ;
	USART_InitStructure.USART_Parity                 = USART_Parity_No               ;
	USART_InitStructure.USART_StopBits               = USART_StopBits_1              ;
	USART_InitStructure.USART_WordLength             = USART_WordLength_8b           ;
	
	USART_Init(USART1,&USART_InitStructure);
	USART_Cmd(USART1,ENABLE);
	
	GPIO_InitStructure.GPIO_Mode  =  GPIO_Mode_AF              ;
	GPIO_InitStructure.GPIO_OType =	 GPIO_OType_PP             ;
	GPIO_InitStructure.GPIO_Pin   =  GPIO_Pin_10 | GPIO_Pin_11 ;
	GPIO_InitStructure.GPIO_PuPd  =  GPIO_PuPd_UP              ;
	GPIO_InitStructure.GPIO_Speed =  GPIO_Speed_100MHz         ;
	GPIO_Init(GPIOB,&GPIO_InitStructure)                       ;
	
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource11,GPIO_AF_USART3);
	GPIO_PinAFConfig(GPIOB,GPIO_PinSource10,GPIO_AF_USART3);
	
	USART_InitStructure.USART_BaudRate               = 9600                          ;
	USART_InitStructure.USART_HardwareFlowControl    = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode                   = USART_Mode_Tx | USART_Mode_Rx ;
	USART_InitStructure.USART_Parity                 = USART_Parity_No               ;
	USART_InitStructure.USART_StopBits               = USART_StopBits_1              ;
	USART_InitStructure.USART_WordLength             = USART_WordLength_8b           ;
	
	USART_Init(USART3,&USART_InitStructure);
	USART_Cmd(USART3,ENABLE);

	
	while(1){
		delayMs(5000);
		for(int i=0;i<8;i++){
		  sprintf(str,"%c\r",buffer_data[i]);
		  delayMs(500);
		  USART_Puts(USART1,str);
		  delayMs(500);
	  }
		while(1);
		
	}	
}

